/*
 * Rs485.c
 *
 *  Created on: 2024518
 *      Author: 34509
 */
#include <thread.h>
#include "uart_dev.h"
#include "thread_communication.h"
#include <string.h>


/* ߳̿ƿָ */
/* ߳̿ƿָ */
static rt_thread_t Recv_thread = RT_NULL;
/* ߳̿ƿָ */
static rt_thread_t Send_thread = RT_NULL;

/*  */
/* ̺߳ */
static void Recv_thread_entry(void* parameter);
/* ̺߳ */
static void Send_thread_entry(void* parameter);



/**
 * @brief   ߳
 * @param
 * @retval
 */
void Recv_thread_Init(void)
{
    Recv_thread =                   /* ߳̿ƿָ */
        rt_thread_create( "Recv",   /* ߳ */
                Recv_thread_entry,  /* ߳ں */
                RT_NULL,            /* ߳ں */
                512,                /* ߳ջС */
                2,                  /* ̵߳ȼ */
                20);                /* ߳ʱƬ */

    /* ̣߳ */
    if (Recv_thread != RT_NULL) {
        rt_thread_startup(Recv_thread);
    }
    else
        return;
}

/**
 * @brief   ߳
 * @param
 * @retval
 */
void Send_thread_Init(void)
{
    Send_thread =                   /* ߳̿ƿָ */
        rt_thread_create( "send",   /* ߳ */
                Send_thread_entry,  /* ߳ں */
                RT_NULL,            /* ߳ں */
                512,                /* ߳ջС */
                3,                  /* ̵߳ȼ */
                20);                /* ߳ʱƬ */

    /* ̣߳ */
    if (Send_thread != RT_NULL) {
        rt_thread_startup(Send_thread);
    }
    else
        return;
}

void Recv_thread_entry(void* parameter)
{
    rt_kprintf("\n Recv \n");
    while (1) {
        read_and_process_uart_data(g_J50RS485_USART3_handle);
        rt_thread_mdelay(100);
    }
}

void Send_thread_entry(void* parameter)
{
    uint8_t buff[100];
    rt_kprintf("\n Send \n");
    while (1) {
        memset(buff, 0, sizeof(buff));
        rt_mq_recv(mqSend, buff, sizeof(buff), RT_WAITING_FOREVER);
        rt_kprintf("\n Send buff \n");
        send_data(buff);
    }
}
